package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.helper.model.EmptyRequest;
import com.iconplus.smartproc.model.request.BidangRequest;
import com.iconplus.smartproc.model.request.DrpApprovalRequest;
import com.iconplus.smartproc.model.response.DrpApprovalResponse;
import com.iconplus.smartproc.model.response.GetListDrpApprovalResponse;
import com.iconplus.smartproc.model.response.GetListUserApprovalResponse;
import com.iconplus.smartproc.service.approval.GetListApprovalDrpServie;
import com.iconplus.smartproc.service.approval.GetListUserDirekturKomiteService;
import com.iconplus.smartproc.service.approval.GetListUserVpService;
import com.iconplus.smartproc.service.approval.PostCreateDrpApprovalService;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;

@CrossOrigin(origins = "${fe.server}", allowCredentials = "true")
@RestController
@RequestMapping("/api/drp/approval")
public class ApprovalDrpController {

    private GetListUserVpService getListUserVpService;
    private GetListUserDirekturKomiteService getListUserDirekturKomiteService;
    private PostCreateDrpApprovalService postCreateDrpApprovalService;
    private GetListApprovalDrpServie getListApprovalDrpServie;
    public ApprovalDrpController(GetListUserVpService getListUserVpService,
                                 GetListUserDirekturKomiteService getListUserDirekturKomiteService,
                                 PostCreateDrpApprovalService postCreateDrpApprovalService,
                                 GetListApprovalDrpServie getListApprovalDrpServie) {
        this.getListUserVpService = getListUserVpService;
        this.getListUserDirekturKomiteService = getListUserDirekturKomiteService;
        this.postCreateDrpApprovalService = postCreateDrpApprovalService;
        this.getListApprovalDrpServie = getListApprovalDrpServie;
    }

    @GetMapping("/vp")
    public GetListUserApprovalResponse getUserVp(EmptyRequest emptyRequest) {
        return getListUserVpService.execute(emptyRequest);
    }

    @GetMapping("direktur-komite")
    public GetListUserApprovalResponse getUserDirekturKomite(EmptyRequest emptyRequest) {
        return getListUserDirekturKomiteService.execute(emptyRequest);
    }

    @PostMapping
    public DrpApprovalResponse createDrpApproval(@RequestBody DrpApprovalRequest drpApprovalRequest) {
        return postCreateDrpApprovalService.execute(drpApprovalRequest);
    }

    @GetMapping
    public GetListDrpApprovalResponse getListDrpApprovalResponse(@RequestParam(name = "search", required = false) String search,
                                                                 @RequestParam(name = "page", defaultValue = "1") Integer page,
                                                                 @RequestParam(name = "size", defaultValue = "5") Integer size) {

        Pageable pageable = PageRequest.of((page - 1), size);
        DrpApprovalRequest drpApprovalRequest = DrpApprovalRequest.builder()
                .search(search)
                .pageable(pageable)
                .build();
        return getListApprovalDrpServie.execute(drpApprovalRequest);

    }
}
